from sqlalchemy import String
from painless_sqlalchemy.columns.AbstractType import AbstractType

VALID_TIMEZONES = [
    'Atlantic/Canary', 'Australia/Melbourne', 'Europe/Lisbon', 'Etc/GMT+0',
    'America/Nipigon', 'America/Miquelon', 'Indian/Reunion',
    'Antarctica/Davis', 'America/Coral_Harbour', 'Asia/Dhaka',
    'America/St_Lucia', 'Australia/LHI', 'Asia/Kashgar', 'America/Phoenix',
    'Asia/Kuwait', 'Asia/Hong_Kong', 'Arctic/Longyearbyen', 'Europe/Guernsey',
    'GB', 'Europe/Paris', 'Europe/Stockholm', 'Pacific/Fiji', 'Pacific/Apia',
    'Pacific/Pago_Pago', 'Asia/Rangoon', 'America/Mexico_City',
    'America/Ensenada', 'America/Puerto_Rico', 'Indian/Mauritius',
    'Europe/Berlin', 'Europe/Zurich', 'Africa/Casablanca', 'Asia/Kuching',
    'Asia/Krasnoyarsk', 'Australia/Canberra', 'Atlantic/Bermuda',
    'Asia/Ujung_Pandang', 'Australia/Currie', 'Asia/Tehran', 'Asia/Saigon',
    'Asia/Baku', 'America/St_Barthelemy', 'America/Porto_Acre',
    'America/Santarem', 'Australia/NSW', 'Libya', 'America/Danmarkshavn',
    'America/Scoresbysund', 'America/Eirunepe', 'America/St_Kitts',
    'Asia/Baghdad', 'Africa/Monrovia', 'Atlantic/Stanley',
    'America/St_Vincent', 'Portugal', 'Europe/Tiraspol', 'America/Vancouver',
    'Asia/Ho_Chi_Minh', 'Europe/Busingen', 'Asia/Thimphu',
    'Africa/Ouagadougou', 'America/Belize', 'America/Port_of_Spain',
    'Greenwich', 'Asia/Tashkent', 'Asia/Tokyo', 'Pacific/Kiritimati',
    'Australia/Sydney', 'Europe/Riga', 'Asia/Dili', 'Africa/Mbabane',
    'Asia/Oral', 'Asia/Aden', 'Europe/Isle_of_Man', 'Europe/Istanbul',
    'Africa/Abidjan', 'Australia/Lindeman', 'US/Michigan', 'Pacific/Galapagos',
    'America/Bogota', 'Africa/Asmara', 'America/Chicago', 'Pacific/Kwajalein',
    'Australia/Broken_Hill', 'America/Cuiaba', 'Indian/Christmas',
    'Asia/Vladivostok', 'Europe/Brussels', 'Asia/Chongqing',
    'America/Argentina/Cordoba', 'Canada/Pacific', 'America/Noronha',
    'Europe/Madrid', 'Africa/Algiers', 'Africa/Harare', 'Africa/Ndjamena',
    'America/Costa_Rica', 'Europe/Ljubljana', 'Indian/Mayotte',
    'Asia/Phnom_Penh', 'America/Managua', 'America/Pangnirtung',
    'America/Tijuana', 'Pacific/Fakaofo', 'America/Adak', 'America/Antigua',
    'America/Indiana/Indianapolis', 'America/Argentina/La_Rioja',
    'Pacific/Tahiti', 'Asia/Brunei', 'Europe/Zagreb', 'America/Asuncion',
    'Europe/Vienna', 'Mexico/General', 'Australia/Hobart', 'America/Juneau',
    'America/Inuvik', 'America/Ojinaga', 'America/Montreal', 'Asia/Seoul',
    'Brazil/East', 'Indian/Comoro', 'Antarctica/Rothera', 'Hongkong',
    'Europe/Tallinn', 'Indian/Mahe', 'Asia/Calcutta', 'Australia/South',
    'America/Argentina/Jujuy', 'America/Creston', 'America/Martinique',
    'Asia/Singapore', 'PRC', 'Africa/Nairobi', 'Asia/Thimbu', 'Asia/Pontianak',
    'America/Maceio', 'Africa/Cairo', 'Europe/Moscow', 'Asia/Pyongyang',
    'Asia/Ulaanbaatar', 'America/Rainy_River', 'Africa/Kampala',
    'Asia/Colombo', 'Australia/Adelaide', 'America/Cambridge_Bay',
    'Africa/Luanda', 'Pacific/Chatham', 'America/Indiana/Winamac',
    'America/Bahia', 'Asia/Dacca', 'America/Cordoba', 'Asia/Tbilisi',
    'Europe/Gibraltar', 'Asia/Karachi', 'Asia/Harbin', 'Australia/Lord_Howe',
    'America/Bahia_Banderas', 'Australia/Tasmania', 'Europe/Nicosia',
    'America/Boa_Vista', 'Eire', 'America/Lima', 'Pacific/Wallis',
    'Canada/Mountain', 'Africa/Lubumbashi', 'America/Blanc-Sablon',
    'Australia/West', 'Antarctica/Syowa', 'America/Jamaica', 'Europe/Kiev',
    'Europe/Budapest', 'Canada/Eastern', 'Pacific/Midway', 'America/Goose_Bay',
    'Antarctica/Vostok', 'Asia/Amman', 'Asia/Sakhalin', 'Africa/Windhoek',
    'US/Pacific', 'America/Sitka', 'Asia/Katmandu', 'America/Guyana',
    'Pacific/Pohnpei', 'America/Sao_Paulo', 'Turkey', 'Australia/Yancowinna',
    'America/Lower_Princes', 'Australia/Perth', 'Africa/Djibouti',
    'Asia/Jakarta', 'Antarctica/Palmer', 'Africa/Johannesburg',
    'Asia/Tel_Aviv', 'Asia/Istanbul',
    'Asia/Irkutsk', 'Iran', 'Australia/ACT', 'Africa/Niamey', 'Pacific/Kosrae',
    'Australia/North', 'America/Belem', 'NZ', 'Africa/Nouakchott',
    'Asia/Ashkhabad', 'Europe/Vilnius', 'America/Cayenne', 'Africa/Mogadishu',
    'America/Kentucky/Monticello', 'America/Rio_Branco', 'America/Cancun',
    'America/Indiana/Knox', 'America/Havana', 'Chile/EasterIsland',
    'Pacific/Guam', 'Antarctica/Macquarie', 'Universal', 'US/Arizona',
    'Atlantic/Azores', 'Australia/Eucla', 'Asia/Shanghai', 'America/Godthab',
    'America/Iqaluit', 'Africa/Maputo', 'Asia/Bahrain', 'Asia/Ashgabat',
    'Asia/Riyadh', 'Atlantic/Faeroe', 'America/Montevideo', 'America/Anguilla',
    'Asia/Damascus', 'America/North_Dakota/Center', 'UCT',
    'America/Indiana/Vevay', 'Atlantic/St_Helena', 'Iceland', 'Europe/Vatican',
    'America/Indiana/Vincennes', 'Asia/Almaty', 'Australia/Queensland',
    'America/Santo_Domingo', 'Africa/Brazzaville', 'America/Nome',
    'Asia/Taipei', 'America/Yakutat', 'Pacific/Samoa',
    'America/Argentina/Mendoza', 'Zulu', 'Egypt', 'America/Araguaina',
    'Etc/UTC', 'Brazil/Acre', 'Africa/Asmera', 'Europe/Minsk',
    'America/Buenos_Aires', 'Asia/Kolkata', 'Africa/Maseru',
    'America/Atikokan', 'America/Louisville', 'Pacific/Yap',
    'America/Santa_Isabel', 'America/Atka', 'Africa/Libreville',
    'Africa/Freetown', 'Africa/Bissau', 'Europe/Samara', 'Europe/Amsterdam',
    'Europe/Tirane', 'Pacific/Saipan', 'Asia/Magadan', 'Europe/Zaporozhye',
    'America/El_Salvador', 'Europe/Podgorica', 'Africa/Juba',
    'America/Santiago', 'America/Argentina/Buenos_Aires',
    'America/Argentina/San_Luis', 'Europe/Skopje', 'America/Aruba',
    'Indian/Cocos', 'America/Indianapolis', 'America/Regina', 'Pacific/Truk',
    'Pacific/Chuuk', 'Asia/Khandyga', 'Pacific/Funafuti', 'Canada/Atlantic',
    'America/Merida', 'America/Guatemala', 'Africa/Sao_Tome', 'Asia/Makassar',
    'Africa/Bujumbura', 'Europe/Chisinau', 'Europe/Warsaw',
    'Asia/Yekaterinburg', 'US/Hawaii', 'Antarctica/Casey', 'Pacific/Enderbury',
    'America/Thule', 'America/St_Johns', 'America/Moncton', 'Europe/Helsinki',
    'Atlantic/Cape_Verde', 'America/Tegucigalpa', 'Navajo', 'America/Boise',
    'America/Guadeloupe', 'America/Nassau', 'Europe/Prague', 'America/Halifax',
    'Asia/Hovd', 'Canada/Saskatchewan', 'America/Manaus',
    'America/Rankin_Inlet', 'Etc/UCT', 'GB-Eire', 'Atlantic/Jan_Mayen',
    'America/North_Dakota/Beulah', 'America/Chihuahua', 'Asia/Beirut',
    'America/Argentina/Rio_Gallegos', 'Pacific/Gambier', 'Europe/Volgograd',
    'Africa/Bamako', 'Asia/Novokuznetsk', 'Europe/Uzhgorod', 'Africa/Banjul',
    'Asia/Aqtau', 'Africa/Malabo', 'America/Argentina/ComodRivadavia',
    'Atlantic/Madeira', 'Pacific/Noumea', 'GMT0', 'Africa/Kinshasa',
    'Europe/Malta', 'US/Samoa', 'America/Argentina/Ushuaia', 'Asia/Chungking',
    'Asia/Bangkok', 'Pacific/Niue', 'America/Catamarca', 'America/Recife',
    'Asia/Yerevan', 'America/La_Paz', 'Poland', 'Asia/Urumqi', 'Africa/Lusaka',
    'US/Indiana-Starke', 'Pacific/Guadalcanal', 'America/Yellowknife',
    'Canada/Newfoundland', 'Asia/Vientiane', 'GMT+0', 'Europe/Kaliningrad',
    'Africa/Conakry', 'America/Argentina/Tucuman', 'Asia/Hebron',
    'Europe/Oslo', 'America/Caracas', 'America/Panama', 'Africa/Gaborone',
    'Pacific/Palau', 'America/Guayaquil', 'Asia/Kuala_Lumpur', 'Europe/London',
    'America/Menominee', 'Asia/Kamchatka', 'Asia/Jayapura',
    'America/Matamoros', 'Brazil/DeNoronha', 'Asia/Kathmandu', 'Asia/Qatar',
    'Israel', 'NZ-CHAT', 'Asia/Dushanbe', 'Asia/Yakutsk', 'Asia/Omsk',
    'Africa/Bangui', 'UTC', 'America/Paramaribo', 'Europe/Belfast',
    'Pacific/Marquesas', 'US/Central', 'Europe/Bratislava', 'Asia/Anadyr',
    'America/New_York', 'Pacific/Norfolk', 'Pacific/Rarotonga',
    'America/Dominica', 'Africa/Porto-Novo', 'Asia/Samarkand',
    'America/Kentucky/Louisville', 'America/Toronto', 'America/Barbados',
    'Indian/Maldives', 'Africa/Accra', 'Antarctica/South_Pole', 'Asia/Muscat',
    'America/Virgin', 'America/Edmonton', 'Pacific/Wake',
    'America/Indiana/Tell_City', 'Australia/Darwin', 'America/Whitehorse',
    'America/Swift_Current', 'Europe/Copenhagen', 'America/Fort_Wayne',
    'America/Montserrat', 'America/Mendoza', 'Europe/Simferopol',
    'Africa/Blantyre', 'America/Detroit', 'America/Shiprock',
    'America/Grenada', 'Atlantic/Faroe', 'America/Indiana/Petersburg',
    'Antarctica/Mawson', 'Asia/Dubai', 'Etc/Universal', 'Africa/Dar_es_Salaam',
    'America/Port-au-Prince', 'America/Cayman', 'Jamaica', 'Europe/Athens',
    'America/Curacao', 'Indian/Kerguelen', 'Africa/Khartoum', 'Asia/Manila',
    'Africa/Lome', 'America/Jujuy', 'Africa/Douala', 'Europe/Rome',
    'America/Argentina/San_Juan', 'America/North_Dakota/New_Salem',
    'America/Kralendijk', 'Pacific/Port_Moresby', 'America/Indiana/Marengo',
    'Europe/Jersey', 'Asia/Macao', 'Europe/Andorra', 'ROK', 'Cuba',
    'Europe/Luxembourg', 'Pacific/Honolulu', 'ROC', 'America/St_Thomas',
    'Pacific/Majuro', 'America/Mazatlan', 'Asia/Macau', 'Europe/Belgrade',
    'Asia/Choibalsan', 'Brazil/West', 'Europe/Mariehamn', 'Antarctica/McMurdo',
    'America/Thunder_Bay', 'America/Los_Angeles', 'Asia/Kabul',
    'Indian/Antananarivo', 'Europe/Sarajevo', 'Atlantic/Reykjavik',
    'Asia/Nicosia', 'Pacific/Ponape', 'Japan', 'Asia/Ulan_Bator', 'Kwajalein',
    'Pacific/Tongatapu', 'America/Marigot', 'Pacific/Pitcairn',
    'Pacific/Easter', 'US/East-Indiana', 'Atlantic/South_Georgia',
    'Africa/El_Aaiun', 'Chile/Continental', 'America/Campo_Grande',
    'America/Dawson_Creek', 'America/Rosario', 'Australia/Victoria',
    'US/Aleutian', 'Europe/Bucharest', 'America/Porto_Velho', 'Europe/Monaco',
    'Asia/Bishkek', 'Africa/Ceuta', 'America/Winnipeg', 'America/Knox_IN',
    'Asia/Aqtobe', 'Africa/Dakar', 'America/Fortaleza', 'W-SU',
    'Pacific/Tarawa', 'America/Dawson', 'Africa/Addis_Ababa', 'Pacific/Efate',
    'Pacific/Johnston', 'GMT', 'Australia/Brisbane', 'Canada/Yukon',
    'Asia/Qyzylorda', 'Europe/San_Marino', 'Asia/Jerusalem',
    'Pacific/Auckland', 'America/Hermosillo', 'America/Metlakatla',
    'America/Tortola', 'Etc/Zulu', 'America/Denver', 'Indian/Chagos',
    'America/Glace_Bay', 'US/Alaska', 'Africa/Tunis', 'Asia/Ust-Nera',
    'Europe/Vaduz', 'America/Resolute', 'Etc/GMT', 'Asia/Gaza',
    'Europe/Dublin', 'US/Mountain', 'Antarctica/DumontDUrville',
    'America/Argentina/Catamarca', 'Antarctica/Troll', 'Africa/Timbuktu',
    'Asia/Novosibirsk', 'Mexico/BajaNorte', 'Africa/Kigali', 'US/Eastern',
    'America/Grand_Turk', 'Mexico/BajaSur', 'America/Argentina/Salta',
    'Canada/Central', 'Africa/Lagos', 'GMT-0', 'Europe/Sofia', 'Singapore',
    'Africa/Tripoli', 'America/Anchorage', 'America/Monterrey',
    'Pacific/Nauru',
    "Etc/GMT-14", "Etc/GMT-13", "Etc/GMT-12", "Etc/GMT-11", "Etc/GMT-10",
    "Etc/GMT-9", "Etc/GMT-8", "Etc/GMT-7", "Etc/GMT-6", "Etc/GMT-5",
    "Etc/GMT-4", "Etc/GMT-3", "Etc/GMT-2", "Etc/GMT-1", "Etc/GMT0",
    "Etc/GMT-0", "Etc/GMT+1", "Etc/GMT+2", "Etc/GMT+3", "Etc/GMT+4",
    "Etc/GMT+5", "Etc/GMT+6", "Etc/GMT+7", "Etc/GMT+8", "Etc/GMT+9",
    "Etc/GMT+10", "Etc/GMT+11", "Etc/GMT+12"
]


class TimeZoneType(String, AbstractType):
    """ Time Zone """

    def result_processor(self, dialect, coltype):
        def process(value):
            return value if value in VALID_TIMEZONES else None
        return process

    def bind_processor(self, dialect):
        def process(bindvalue):
            return bindvalue if bindvalue in VALID_TIMEZONES else None
        return process

    def validator(self, attr_name):
        def validate(target, value, oldvalue, initiator):  # pylint: disable=unused-argument
            if value is not None:
                if value not in VALID_TIMEZONES:
                    raise ValueError('Invalid Time Zone "%s".' % value)
            return True
        return validate
